k = 2*pi*1;
w = k*343;
L = 4.4;
x0 = 3.2;
x_up = 0:0.001:x0;
x_down = x0+0.001:0.001:L;
x = [x_up x_down];

% Normalized pressure and particle velocity variables

% p_up = -j*cos(k*(L-x0))*cos(k*x_up);
% p_down = -j*cos(k*x0)*cos(k*(L-x_down));
% p = [p_up p_down];
% 
% u_up = -cos(k*(L-x0))*sin(k*x_up);
% u_down = cos(k*x0)*sin(k*(L-x_down));
% u = [u_up u_down];

An = -j*cos(k*(L-x0));
Bn = An;
Cn = -j*cos(k*x0)*exp(j*k*L);
Dn = -j*cos(k*x0)*exp(-j*k*L);

p_up = An*exp(-j*k*x_up)+Bn*exp(j*k*x_up);
p_down = Cn*exp(-j*k*x_down)+Dn*exp(j*k*x_down);
p = [p_up p_down];

u_up = An*exp(-j*k*x_up)-Bn*exp(j*k*x_up);
u_down = Cn*exp(-j*k*x_down)-Dn*exp(j*k*x_down);
u = [u_up u_down];

t = 0;

figure
subplot(211)
hp = plot(x,real(p*exp(j*w*t)));
set(hp,'EraseMode','xor');
grid
axis([0 L -2 2])
title('normalized p(x,t)')
hold on
plot(x0*[1 1],[-2 2],'b--')
hold off

subplot(212)
hu = plot(x,real(u*exp(j*w*t)));
set(hu,'EraseMode','xor');
grid
axis([0 L -2 2])
title('normalized u(x,t)')
hold on
plot(x0*[1 1],[-2 2],'b--')
xlabel('CTRL-C to terminate')
hold off

while 1
   t = t+0.0001;
   set(hp,'YData',real(p*exp(j*w*t)));
   set(hu,'YData',real(u*exp(j*w*t)));
   pause(0.03)
   drawnow
end
