k = 2*pi*1;
w = k*343;
L = 4.4;
x = 0:0.001:L;

% Optimal multiplicative factor for the secondary source 
ks = -exp(-j*k*L);

% Normalized pressure and particle velocity variables
Cnp = -j*exp(j*k*L);
Dnp = -j*exp(-j*k*L);
pp = Cnp*exp(-j*k*x)+Dnp*exp(j*k*x);
up = Cnp*exp(-j*k*x)-Dnp*exp(j*k*x);

Ans = ks*(-j);
Bns = ks*An;
ps = Ans*exp(-j*k*x)+Bns*exp(j*k*x);
us = Ans*exp(-j*k*x)-Bns*exp(j*k*x);

t = 0;

figure
subplot(211)
hpp = plot(x,real(pp*exp(j*w*t)));
set(hpp,'EraseMode','xor');
grid
axis([0 L -2 2])
title('normalized p(x,t) (primary = blue, secondary = green, total = red)')
hold on
plot([0 0],[-2 2],'b--')
hps = plot(x,real(ps*exp(j*w*t)),'g');
set(hps,'EraseMode','xor');
plot(L*[1 1],[-2 2],'g--')
hptot = plot(x,real(pp*exp(j*w*t))+real(ps*exp(j*w*t)),'r');
set(hptot,'EraseMode','xor','LineWidth',2);
hold off

subplot(212)
hup = plot(x,real(up*exp(j*w*t)));
set(hup,'EraseMode','xor');
grid
axis([0 L -2 2])
title('normalized u(x,t) (primary = blue, secondary = green, total = red)')
hold on
plot([0 0],[-2 2],'b--')
hus = plot(x,real(us*exp(j*w*t)),'g');
set(hus,'EraseMode','xor');
plot(L*[1 1],[-2 2],'g--')
hutot = plot(x,real(up*exp(j*w*t))+real(us*exp(j*w*t)),'r');
set(hutot,'EraseMode','xor','LineWidth',2);
xlabel('CTRL-C to terminate')
hold off

while 1
   t = t+0.0001;
   set(hpp,'YData',real(pp*exp(j*w*t)));
   set(hps,'YData',real(ps*exp(j*w*t)));
   set(hptot,'YData',real(pp*exp(j*w*t))+real(ps*exp(j*w*t)));
   set(hup,'YData',real(up*exp(j*w*t)));
   set(hus,'YData',real(us*exp(j*w*t)));
   set(hutot,'YData',real(up*exp(j*w*t))+real(us*exp(j*w*t)));
   pause(0.03)
   drawnow
end
