k = 2*pi*1;
w = k*343;
L = 2.2;
x = -3:0.001:3;

% Monopole: normalized variables
pm = exp(-j*k*abs(x));
um = [exp(-j*k*abs(x)).*sign(x)];

% Dipole: normalized variables
pd = [exp(-j*k*abs(x)).*sign(x)];
ud = exp(-j*k*abs(x));

t = 0;

figure
subplot(211)
hpm = plot(x,real(pm*exp(j*w*t)));
set(hpm,'EraseMode','xor');
grid
axis([-3 3 -1 1])
title('normalized p(x,t) (monopole = blue, dipole = green, total = red)')
hold on
plot([0 0],[-1 1],'b--')
hpd = plot(x,real(pd*exp(j*w*t)),'g');
set(hpd,'EraseMode','xor');
hptot = plot(x,real(0.5*pm*exp(j*w*t))+real(0.5*pd*exp(j*w*t)),'r');
set(hptot,'EraseMode','xor','LineWidth',2);
hold off

subplot(212)
hum = plot(x,real(um*exp(j*w*t)));
set(hum,'EraseMode','xor');
grid
axis([-3 3 -1 1])
title('normalized u(x,t) (monopole = blue, dipole = green, total = red)')
hold on
plot([0 0],[-1 1],'b--')
hud = plot(x,real(ud*exp(j*w*t)),'g');
set(hud,'EraseMode','xor');
hutot = plot(x,real(0.5*um*exp(j*w*t))+real(0.5*ud*exp(j*w*t)),'r');
set(hutot,'EraseMode','xor','LineWidth',2);
xlabel('CTRL-C to terminate')
hold off

while 1
   t = t+0.0001;
   set(hpm,'YData',real(pm*exp(j*w*t)));
   set(hpd,'YData',real(pd*exp(j*w*t)));
   set(hptot,'YData',real(0.5*pm*exp(j*w*t))+real(0.5*pd*exp(j*w*t)));
   set(hum,'YData',real(um*exp(j*w*t)));
   set(hud,'YData',real(ud*exp(j*w*t)));
   set(hutot,'YData',real(0.5*um*exp(j*w*t))+real(0.5*ud*exp(j*w*t)));
   pause(0.03)
   drawnow
end
hold off
