k = 2*pi*1;
w = k*343;
L = 1.2;
d = 0.4;
x = -3:0.001:3;

% Optimal multiplicative factor for the secondary sources
ks2 = -exp(-j*k*L)/(2*j*sin(k*d));
ks1 = -exp(-j*k*d)*ks2;  

% Pressures and particle velocities
pp = exp(-j*k*abs(x));
up = exp(-j*k*abs(x)).*sign(x);
ps1 = ks1*exp(-j*k*abs(x-L));
us1 = ks1*exp(-j*k*abs(x-L)).*sign(x-L);
ps2 = ks2*exp(-j*k*abs(x-L-d));
us2 = ks2*exp(-j*k*abs(x-L-d)).*sign(x-L-d);

t = 0;

figure
subplot(211)
hpp = plot(x,real(pp*exp(j*w*t)));
set(hpp,'EraseMode','xor');
grid
axis([-3 3 -2 2])
title('normalized p(x,t) (primary = blue, secondary = green/magenta, total = red)')
hold on
plot([0 0],[-2 2],'b--')
hps1 = plot(x,real(ps1*exp(j*w*t)),'g');
set(hps1,'EraseMode','xor');
plot(L*[1 1],[-2 2],'g--')
hps2 = plot(x,real(ps2*exp(j*w*t)),'m');
set(hps2,'EraseMode','xor');
plot((L+d)*[1 1],[-2 2],'m--')
hptot = plot(x,real(pp*exp(j*w*t))+real(ps1*exp(j*w*t))+real(ps2*exp(j*w*t)),'r');
set(hptot,'EraseMode','xor','LineWidth',2);
hold off

subplot(212)
hup = plot(x,real(up*exp(j*w*t)));
set(hup,'EraseMode','xor');
grid
axis([-3 3 -2 2])
title('normalized u(x,t) (primary = blue, secondary = green/magenta, total = red)')
hold on
plot([0 0],[-2 2],'b--')
hus1 = plot(x,real(us1*exp(j*w*t)),'g');
set(hus1,'EraseMode','xor');
plot(L*[1 1],[-2 2],'g--')
hus2 = plot(x,real(us2*exp(j*w*t)),'m');
set(hus2,'EraseMode','xor');
plot((L+d)*[1 1],[-2 2],'m--')
hutot = plot(x,real(up*exp(j*w*t))+real(us1*exp(j*w*t))+real(us2*exp(j*w*t)),'r');
set(hutot,'EraseMode','xor','LineWidth',2);
xlabel('CTRL-C to terminate')
hold off

while 1
   t = t+0.0001;
   set(hpp,'YData',real(pp*exp(j*w*t)));
   set(hps1,'YData',real(ps1*exp(j*w*t)));
   set(hps2,'YData',real(ps2*exp(j*w*t)));
   set(hptot,'YData',real(pp*exp(j*w*t))+real(ps1*exp(j*w*t))+real(ps2*exp(j*w*t)));
   set(hup,'YData',real(up*exp(j*w*t)));
   set(hus1,'YData',real(us1*exp(j*w*t)));
   set(hus2,'YData',real(us2*exp(j*w*t)));
   set(hutot,'YData',real(up*exp(j*w*t))+real(us1*exp(j*w*t))+real(us2*exp(j*w*t)));
   pause(0.03)
   drawnow
end
