k = 2*pi*1;
w = k*343;
D = 0.6;
L = 2.2;
R = 1;            % Reflection coefficient
x = -3:0.001:3;
x0 = ceil(length(x)/2);

% Optimal multiplicative factor for the secondary source 
ks = -((exp(j*k*D)+R*exp(-j*k*D))/(exp(j*k*L)+R*exp(-j*k*L)));  

% Pressures and particle velocities
pp = exp(-j*k*abs(x-D));
up = exp(-j*k*abs(x-D)).*sign(x-D);
ps = ks*exp(-j*k*abs(x-L));
us = ks*exp(-j*k*abs(x-L)).*sign(x-L);

% Reflected pressures and particle velocities
ppR = R*exp(-j*k*abs(x+D));
upR = R*exp(-j*k*abs(x+D)).*sign(x+D);
psR = R*ks*exp(-j*k*abs(x+L));
usR = R*ks*exp(-j*k*abs(x+L)).*sign(x+L);

t = 0;

figure
subplot(221)
hpp = plot(x,real(pp*exp(j*w*t)),'b');
set(hpp,'EraseMode','xor');
grid
axis([-3 3 -5 5])
title('normalized p(x,t)\newline(primary = blue, secondary = green, total = red)')
hold on
plot([0 0],[-5 5],'k')
plot(D*[1 1],[-5 5],'b--')
hps = plot(x,real(ps*exp(j*w*t)),'g');
set(hps,'EraseMode','xor');
plot(L*[1 1],[-5 5],'g--')
hppR = plot(x,real(ppR*exp(j*w*t)),'b:');
set(hppR,'EraseMode','xor');
plot(-D*[1 1],[-5 5],'b:')
hpsR = plot(x,real(psR*exp(j*w*t)),'g:');
set(hpsR,'EraseMode','xor');
plot(-L*[1 1],[-5 5],'g:')
hptot = plot(x,real((pp+ps+ppR+psR)*exp(j*w*t)),'r');
set(hptot,'EraseMode','xor','LineWidth',2);
xlabel('Real and image sources')
hold off

subplot(223)
hup = plot(x,real(up*exp(j*w*t)),'b');
set(hup,'EraseMode','xor');
grid
axis([-3 3 -5 5])
title('normalized u(x,t)\newline(primary = blue, secondary = green, total = red)')
hold on
plot([0 0],[-5 5],'k')
plot(D*[1 1],[-5 5],'b--')
hus = plot(x,real(us*exp(j*w*t)),'g');
set(hus,'EraseMode','xor');
plot(L*[1 1],[-5 5],'g--')
hupR = plot(x,real(upR*exp(j*w*t)),'b:');
set(hupR,'EraseMode','xor');
plot(-D*[1 1],[-5 5],'b:')
husR = plot(x,real(usR*exp(j*w*t)),'g:');
set(husR,'EraseMode','xor');
plot(-L*[1 1],[-5 5],'g:')
hutot = plot(x,real((up+us+upR+usR)*exp(j*w*t)),'r');
set(hutot,'EraseMode','xor','LineWidth',2);
xlabel('Real and image sources\newlineCTRL-C to terminate')
hold off

subplot(222)
hpp2 = plot(x(x0:end),real((pp(x0:end)+ppR(x0:end))*exp(j*w*t)),'b');
set(hpp2,'EraseMode','xor');
grid
axis([-3 3 -5 5])
title('normalized p(x,t)\newline(primary = blue, secondary = green, total = red)')
hold on
plot(D*[1 1],[-5 5],'b--')
hps2 = plot(x(x0:end),real((ps(x0:end)+psR(x0:end))*exp(j*w*t)),'g');
set(hps2,'EraseMode','xor');
plot(L*[1 1],[-5 5],'g--')
hptot2 = plot(x(x0:end),real((pp(x0:end)+ps(x0:end)+ppR(x0:end)+psR(x0:end))*exp(j*w*t)),'r');
set(hptot2,'EraseMode','xor','LineWidth',2);
xlabel('Actual waves')
hold off

subplot(224)
hup2 = plot(x(x0:end),real((up(x0:end)+upR(x0:end))*exp(j*w*t)),'b');
set(hup2,'EraseMode','xor');
grid
axis([-3 3 -5 5])
title('normalized u(x,t)\newline(primary = blue, secondary = green, total = red)')
hold on
plot(D*[1 1],[-5 5],'b--')
hus2 = plot(x(x0:end),real((us(x0:end)+usR(x0:end))*exp(j*w*t)),'g');
set(hus2,'EraseMode','xor');
plot(L*[1 1],[-5 5],'g--')
hutot2 = plot(x(x0:end),real((up(x0:end)+us(x0:end)+upR(x0:end)+usR(x0:end))*exp(j*w*t)),'r');
set(hutot2,'EraseMode','xor','LineWidth',2);
xlabel('Actual waves\newlineCTRL-C to terminate')
hold off


while 1
   t = t+0.0001;
   set(hpp,'YData',real(pp*exp(j*w*t)));
   set(hps,'YData',real(ps*exp(j*w*t)));
   set(hppR,'YData',real(ppR*exp(j*w*t)));
   set(hpsR,'YData',real(psR*exp(j*w*t)));
   set(hptot,'YData',real((pp+ps+ppR+psR)*exp(j*w*t)));
   set(hup,'YData',real(up*exp(j*w*t)));
   set(hus,'YData',real(us*exp(j*w*t)));
   set(hupR,'YData',real(upR*exp(j*w*t)));
   set(husR,'YData',real(usR*exp(j*w*t)));
   set(hutot,'YData',real((up+us+upR+usR)*exp(j*w*t)));

   set(hpp2,'YData',real((pp(x0:end)+ppR(x0:end))*exp(j*w*t)));
   set(hps2,'YData',real((ps(x0:end)+psR(x0:end))*exp(j*w*t)));
   set(hup2,'YData',real((up(x0:end)+upR(x0:end))*exp(j*w*t)));
   set(hus2,'YData',real((us(x0:end)+usR(x0:end))*exp(j*w*t)));
   set(hptot2,'YData',real((pp(x0:end)+ps(x0:end)+ppR(x0:end)+psR(x0:end))*exp(j*w*t)));
   set(hutot2,'YData',real((up(x0:end)+us(x0:end)+upR(x0:end)+usR(x0:end))*exp(j*w*t)));
   pause(0.03)
   drawnow
end
